require "ui.globals"
require "ui.config"
require "ui.colors"
require "ui.init"
require "ui.draw"
require "ui.keyboard"
require "ui.mouse"


function love.load()
    love.window.setTitle("Sudoku!")
    love.window.setMode(0, 0)
    love.mouse.setGrabbed(false)
    love.keyboard.setKeyRepeat(true)
    math.randomseed(os.time())
    initSmallNumbers()
    initGrid()
    messages[1] = "Game Info"
end

function love.update(dt)
end

function love.draw()
    -- love.graphics.setBackgroundColor(colors.backGround)
    setBackgroundColor(colors.backGround)
    drawGrid()
    drawSmallNumbers()
    drawCursor()
    drawMessages()
    love.graphics.setFont(fonts.bigNum)
    love.graphics.print("5", grid[5][5].x1+25, grid[5][5].y1+10)
end
